Subject: Re: [PATCH net-next 1/5] sctp: add the rhashtable apis for sctp global transport hashtable

From: Marcelo Ricardo Leitner <[email-masked]>
Date: Mon, 11 Jan 2016 14:33:37 -0200

On Mon, Jan 11, 2016 at 05:32:10PM +0800, Herbert Xu wrote:
> David Miller <[email-masked]> wrote:
> > From: Eric Dumazet <[email-masked]>
> > Date: Wed, 30 Dec 2015 11:57:31 -0500
> > 
> >> I am against using rhashtable in SCTP (or TCP) at this stage, given the
> >> number of bugs we have with it.
> > 
> > Come on Eric, we've largely dealt with all of these problems.  I haven't
> > seen a serious report in a while.
> 
> Well there is still the outstanding issue with softirq insertion
> potentially failing with ENOMEM if we fail to expand the hash
> table using just kmalloc.
> 
> So if the target user does softirq insertions, I would wait until
> the fix for that is ready.

It does some, yes. If listening socket is not backlogged, there will be
N inserts at each new association, where N is the number of IP addresses
that the client is advertising.

This is done on the second stage of the SCTP handshake. Not easily
DoS-able as it requires receiving a packet from server and replying
based on it, plus N is limited by MTU.

AFAIK Xin's stress tests couldn't hit this situation of ENOMEM, btw.

Thanks,
Marcelo